// apt_dat.cxx
#pragma warning( disable:4996 )  // unsafe ...

#include "gshhs_vers.h"
#include <windows.h>
#include <stdio.h>      // for sprtf(...)

#include "zlib.h"
#include "gshhs_win.h"
#include "gshhs_list.h"
#include "apt_dat.h"
#include "sprtf.h"

#ifndef  NO_ADD_FG_DATA

#define  MALLOC(a)   malloc(a)
#define  MFREE(a)    free(a)

// options
int iVerbal = 0;
int bAdd_All_Taxi = 1;     // *** ALWAYS ADD ALL to the LIST at least ***
// whether it is PAINTED to the bitmap should depend on the USERS fg:all (

static char buf[FG_MX_BUFF+1];
static char fg_id[FG_ID_MAX];
static char fg_name[FG_NAME_MAX];
static char last_fg_id[FG_ID_MAX];
static char last_fg_name[FG_NAME_MAX];
static char last_apt_type[FG_TYPE_MAX];
static char token_num[FG_ID_MAX];
static char rwy_no[FG_MAX_RWN];

static char * tokens[FG_MAX_TOKENS];
static int tok_count;

#ifndef CHKMEM
#define  CHKMEM(a,b) if(!a) { sprtf("ERROR: MEMORY FAILED %d bytes!\n", b); exit(-1); }
#endif

LE   airport_list = { &airport_list, &airport_list };
LE   runway_list = { &runway_list, &runway_list };

PLE   Get_Airports_List( void )
{
   return &airport_list;
}

PLE   Get_Runways_List( void )
{
   return &runway_list;
}


PFGAPT Add_Airport_List( PLE ph, char * apt_id, double lon, double lat, double elev, char * apt_name )
{
   PFGAPT papt = (PFGAPT)MALLOC( sizeof(FGAPT) );
   CHKMEM(papt, sizeof(FGAPT));
   strcpy(papt->apt_id, apt_id);
   papt->lon = lon;
   papt->lat = lat;
   papt->elev = elev;
   strcpy(papt->apt_name, apt_name);
   InsertTailList(ph,(PLE)papt);
   return papt;
}

PFGAPT Add_Airport( char * apt_id, double lon, double lat, double elev, char * apt_name )
{
   PLE ph = &airport_list;
   return Add_Airport_List( ph, apt_id, lon, lat, elev, apt_name );
}


//           width, displ_thresh1, displ_thresh2,
//           stopway1, stopway2, lighting_flags, surface_code,
//           shoulder_code, marking_code, smoothness,
//           dist_remaining );
PFGRWY Add_Runway_List( PLE ph, char * apt_id, char * rwy_no,
                  double lon, double lat, double heading, double length,
                  double width )
{
   char * prno;
   size_t len;
   if( bAdd_All_Taxi || strcmp(rwy_no,"xxx") ) {
      PFGRWY prwy = (PFGRWY)MALLOC( sizeof(FGRWY) );
      CHKMEM(prwy, sizeof(FGRWY));
      strcpy(prwy->rwy_id, apt_id);
      prno = prwy->rwy_no;
      strcpy(prno, rwy_no);
      if( strcmp(prno,"xxx") ) {
         // is RUNWAY
         prwy->type = FG_RUNWAY;
         len = strlen(prno);
         if(len) {
            len--;
            if( prno[len] == 'x' )
               prno[len] = 0;
         }
      } else {
         // is TAXIWAY - leave as "xxx"
         prwy->type = FG_TAXIWAY;
      }
      prwy->lat = lat;
      prwy->lon = lon;
      prwy->heading = heading;
      prwy->length = length;
      prwy->width = width;
      // insert into LIST
      InsertTailList(ph,(PLE)prwy);
      return prwy;
   }
   return NULL;
}

PFGRWY Add_Runway( char * apt_id, char * rwy_no,
                  double lon, double lat, double heading, double length,
                  double width )
{
   if( bAdd_All_Taxi || strcmp(rwy_no,"xxx") ) {
      PLE ph = &runway_list;
      return Add_Runway_List( ph, apt_id, rwy_no,
         lon, lat, heading, length, width );
   }
   return NULL;
}

void Show_Signature( char * buf )
{
   char * cp = buf;
   while( *cp ) {
      if( memcmp(cp, ".net).", 6) == 0 ) {
         cp[6] = 0;
         cp = 0;
         break;
      }
      cp++;
   }
   if( cp ) {
      // failed to find '.net).' in data, Just take the version bits
      cp = buf;   // start again ...
      while( *cp && (*cp > ' ')) cp++;
      while( *cp && (*cp <= ' ')) cp++;
      while( *cp && (*cp > ' ')) cp++;
      *cp = 0;
   }
   if( iVerbal > 2 ) {
      sprtf( "X-Plane Data - %s\n", buf );
   }
}

int FG_Data_Load_Data_File( char * pfile )
{
   int   added_count = 0;
   unsigned int line_num = 0;
   int   line_id;
   int   iverb = iVerbal;
   gzFile gzf = gzopen(pfile, "rb");
   if( gzf ) {
      double lat, lon;
      double rwy_lat_accum = 0.0;
      double rwy_lon_accum = 0.0;
      int   rwy_count = 0;
      int   taxi_count = 0;
      char * plast_apt_id = last_fg_id;
      char * plast_apt_name = last_fg_name;
      double last_apt_elev = 0.0;
      char * plast_apt_type = last_apt_type;
      char * papt_id = fg_id;  // current airport ID
      int   apt_count = 0;
      char * cp = gzgets( gzf, buf, 2048 ); // int rd = gzread( gzf, buf, 2048 );
      double elev;
      int i;
      char * prwy_no = rwy_no;
      double heading, length, width;

      *plast_apt_id = 0;
      do {
         size_t len = strlen(buf);
         while(len--) {
            if( buf[len] > ' ' )
               break;
            buf[len] = 0;
         }
         cp = buf;
         len = strlen(cp);
         line_num++;
         tok_count = 0;
         tokens[tok_count++] = buf;
         if( len > 0 ) {
            if (len >= 3) {
               char *p = (char *)memchr(buf, ' ', 3);
               if ( p ) {
                  *p = 0;
                  p++;
                  cp = p;
                  while( *cp && (*cp <= ' ')) cp++;
               }
            }
            line_id = atoi(buf);
            if( buf[0] == 'I' ) {
               gzgets( gzf, buf, 2048 );
               line_num++;
               cp = buf;
               Show_Signature(buf);
            } else if ( line_id == 1 ||   /* Airport */ 
               line_id == 16 ||          /* Seaplane base */
               line_id == 17 ) {          /* Heliport */
               apt_count++;
               //cout << line << endl;
               if( cp != buf )
                  tokens[tok_count++] = cp;
               while( *cp ) {
                  while( *cp > ' ' ) cp++;
                  if( *cp ) {
                     *cp = 0;
                     cp++;
                     while( *cp && (*cp <= ' ') ) cp++;
                     tokens[tok_count++] = cp;
                     if(tok_count >= FG_MAX_TOKENS )
                        break;
                  }
               }
               strcpy( papt_id, tokens[4] );
               elev = atof( tokens[1] );
               //cout << apt_count << " " << apt_id << " " << elev << endl;
               if ( strlen(plast_apt_id)) {
                  if ( rwy_count > 0 ) {
                     lat = rwy_lat_accum / (double)rwy_count;
                     lon = rwy_lon_accum / (double)rwy_count;
                     Add_Airport( plast_apt_id, lon, lat, last_apt_elev, plast_apt_name ); //, false );
                     added_count++;
                     // Hong Kong - VHHH
                     //if( strcmp(plast_apt_id,"VHHH") == 0 )
                     //   iverb = 1;
                     //if( strcmp(plast_apt_id,"YSSY") == 0 )
                     //   iverb = 1;
                     //if( strcmp(plast_apt_id,"LFPG") == 0 )
                     //   iverb = 1;
                     //if( strcmp(plast_apt_id,"LFPO") == 0 )
                     //   iverb = 1;
                     if(iverb) {
                        sprtf( "%d: %s %3.6f,%3.6f,%3.1f %s (rwys=%d,txi=%d)\n",
                           added_count, plast_apt_id, lat, lon, last_apt_elev,
                           plast_apt_name, (rwy_count - taxi_count), taxi_count );
                     }
                     iverb = iVerbal;
                   } else {
                     if ( !strlen(plast_apt_id) ) {
                        // SG_LOG(SG_GENERAL, SG_ALERT,
                        //cout << "ERROR: No runways for " << last_apt_id << " skipping." << endl;
                     }
                  }
               }
               strcpy(plast_apt_id, papt_id);
               last_apt_elev = atof( tokens[1] );
               *plast_apt_name = 0;
               // build the name
               for ( i = 5; i < tok_count - 1; ++i ) {
                  strcat(plast_apt_name, tokens[i]);
                  strcat(plast_apt_name, " ");
               }
               strcat(plast_apt_name, tokens[tok_count - 1]);
               //last_apt_info = line;
               strcpy(plast_apt_type, tokens[0]);

               // clear runway list for start of next airport
               rwy_lon_accum = 0.0;
               rwy_lat_accum = 0.0;
               rwy_count = 0;
               taxi_count = 0;

            } else if ( line_id == 10 ) { // runways AND taxiways
               if( cp != buf )
                  tokens[tok_count++] = cp;
               while( *cp ) {
                  while( *cp > ' ' ) cp++;
                  if( *cp ) {
                     *cp = 0;
                     cp++;
                     while( *cp && (*cp <= ' ') ) cp++;
                     tokens[tok_count++] = cp;
                     if(tok_count >= FG_MAX_TOKENS )
                        break;
                  }
               }
               // runway entry
               lat = atof( tokens[1] );
               lon = atof( tokens[2] );
               rwy_lat_accum += lat;
               rwy_lon_accum += lon;
               rwy_count++;

               strcpy(prwy_no, tokens[3]);
               heading = atof( tokens[4] );
               length = atoi( tokens[5] );
               width = atoi( tokens[8] );
               //string rwy_displ_threshold = token[6];
               //vector<string> displ = split_on_sep( rwy_displ_threshold, ".", 0 );
               //double displ_thresh1 = atof( displ[0].c_str() );
               //double displ_thresh2 = atof( displ[1].c_str() );

               //string rwy_stopway = token[7];
               //vector<string> stop = split_on_sep( rwy_stopway, ".", 0 );
               //double stopway1 = atof( stop[0].c_str() );
               //double stopway2 = atof( stop[1].c_str() );

               //string lighting_flags = token[9];
               //int surface_code = atoi( token[10].c_str() );
               //string shoulder_code = token[11];
               //int marking_code = atoi( token[12].c_str() );
               //double smoothness = atof( token[13].c_str() );
               //bool dist_remaining = (atoi( token[14].c_str() ) == 1 );
               if( strcmp(prwy_no, "xxx" ) == 0 ) {
                  taxi_count++;
                  if( bAdd_All_Taxi )
                     Add_Runway( plast_apt_id, prwy_no, lon, lat, heading, length, width );
                  if( iVerbal >= 3 ) {
                     sprtf("%s # %s, %3.6f,%3.6f, %3.2f, %5.2f\n",
                        plast_apt_id, prwy_no,
                        lat, lon, heading, length );
                     //   " wid " << width << endl;
                     //, displ_thresh1, displ_thresh2,
                     //        stopway1, stopway2, lighting_flags, surface_code,
                     //        shoulder_code, marking_code, smoothness,
                     //        dist_remaining );
                  }
               } else {
                  Add_Runway( plast_apt_id, prwy_no, lon, lat, heading, length, width );
                  //           width, displ_thresh1, displ_thresh2,
                  //           stopway1, stopway2, lighting_flags, surface_code,
                  //           shoulder_code, marking_code, smoothness,
                  //           dist_remaining );
                  if( iVerbal >= 2 ) {
                     sprtf("%s # %s, %3.6f,%3.6f, %3.2f, %5.2f\n",
                        plast_apt_id, prwy_no,
                        lat, lon, heading, length );
                  }
               }
            } else if ( line_id == 18 ) {
                  // beacon entry (ignore)
            } else if ( line_id == 14 ) {
                  // control tower entry (ignore)
            } else if ( line_id == 19 ) {
                  // windsock entry (ignore)
            } else if ( line_id == 15 ) {
                  // custom startup locations (ignore)
            } else if ( line_id >= 50 && line_id <= 56 ) {
                  // frequency entries (ignore)
            } else if ( line_id == 99 ) {
                  //cout << line_num << " - End of file reached" << endl;
               if( iVerbal >= 2 ) {
                  sprtf( "Line %u: - End of file reached. (99)\n", line_num );
               }
            } else if ( line_id == 0 ) {
               // some extra lines???
            } else {
               //cout << "Line # " << line_num << " - Unknown line in file! id = " <<
               //   line_id << " line is: " << line << endl;
               //exit(-1);
            }
         }
      } while( ( cp = gzgets( gzf, buf, 2048 ) ) != Z_NULL );
      gzclose( gzf );
      if ( strlen(plast_apt_id) ) {
         if ( rwy_count > 0 ) {
            double lat = rwy_lat_accum / (double)rwy_count;
            double lon = rwy_lon_accum / (double)rwy_count;
            //airports->add( last_apt_id, lon, lat, last_apt_elev,
            //              last_apt_name, false );
            Add_Airport( plast_apt_id, lon, lat, last_apt_elev, plast_apt_name ); //, false );
            added_count++;
            if(iVerbal) {
               sprtf( "%d: %s %3.6f,%3.6f,%3.1f %s (rwys=%d,txi=%d)\n",
                  added_count, plast_apt_id, lat, lon, last_apt_elev,
                  plast_apt_name, (rwy_count - taxi_count), taxi_count );
            }
         } else {
            if ( strlen(plast_apt_id) ) {
               // SG_LOG(SG_GENERAL, SG_ALERT,
               sprtf( "ERROR: No runways for %s, skipping ...\n", plast_apt_id );
            }
         }
      }
   } else {
     //cout << "ERROR: Failed to open file [" << pfile << "]!" << endl;
     sprtf( "ERROR: Failed to open file [%s]!\n", pfile );
   }
   return added_count;  // return AIRPORTS count loaded
}

void Kill_List( void * pv )
{
   KillLList((PLE)pv);
}

void Kill_Linked_Lists( void )
{
   if( iVerbal )
      sprtf( "Killing linked lists ..." );
   Kill_List( &airport_list );
   Kill_List( &runway_list );
   if( iVerbal )
      sprtf( " Done...\n" );
}

void FG_Data_get_apts_in_bounds( double n, double s, double e, double w,
                                PLE phapts, PLE phrwys )
{
   int cnt;
   int len;
   PLE ph = &airport_list;
   PLE phr = &runway_list;
   //const FGAirport * papt;
   //string id;
   PLE   pn, pnr;
   PFGAPT papt;
   PFGRWY prwy;
   ListCount2(ph,&len);
   if( iVerbal >= 2 ) {
      sprtf( "Searching %d airports in bounds, max lat(N) %3.6f, min lat(S) %3.6f, max lon(E) %3.6f min lon(W) %3.6f\n",
         len, n, s, e, w );
   }

   Traverse_List(ph, pn)
   {
      papt = (PFGAPT)pn;
      if(papt) {
         double lat = papt->lat;
         double lon = papt->lon;
         if(( lat <= n )&&
            ( lat >= s )&&
            ( lon <= e )&&
            ( lon >= w ))
         {
            Add_Airport_List( phapts,
               papt->apt_id, papt->lon, papt->lat, papt->elev, papt->apt_name );
         }
      }
   }

   ListCount2(phapts,&len);
   if( len && phrwys ) {
      Traverse_List( phapts, pn )
      {
         papt = (PFGAPT)pn;
         cnt = 0;
         Traverse_List( phr, pnr )
         {
            prwy = (PFGRWY)pnr;
            if( strcmp( papt->apt_id, prwy->rwy_id ) == 0 )
            {
               cnt++;
               Add_Runway_List( phrwys,
                  prwy->rwy_id, prwy->rwy_no,
                  prwy->lon, prwy->lat, prwy->heading,
                  prwy->length, prwy->width );
            }
         }
         if(cnt) {
            if( iVerbal ) {
               sprtf( "Found %d runways for airport id %s\n",
                  cnt, papt->apt_id );
            }
         } else {
            sprtf( "Found NO runways for airport id %s\n", papt->apt_id );
         }
      }
   }
}

typedef struct tagFGRWYDETAILS {
   int done;
   double n, s, e, w;
   double bn, bs, be, bw;

   PFGAPT papt;   // the AIRPORT
   PFGRWY prwy;   // the runway, or taxiway
   double end1_lat, end1_lon;
   double end2_lat, end2_lon;
   double   hdg1, hdg2;
   double cnr1_lat, cnr1_lon, hcnr1;
   double cnr2_lat, cnr2_lon, hcnr2;
   double cnr3_lat, cnr3_lon, hcnr3;
   double cnr4_lat, cnr4_lon, hcnr4;
   double chk_lat, chk_lon, hchk;
   double chk_dist, az1, az2;
   double   diff_lat, diff_lon;
   int cnr1_ilat, cnr1_ilon;
   int cnr2_ilat, cnr2_ilon;
   int cnr3_ilat, cnr3_ilon;
   int cnr4_ilat, cnr4_ilon;
}FGRWYDETAILS, * PFGRWYDETAILS;

static FGRWYDETAILS rwyd;

#define  NomalizeHeading(a) if( a > 360.0 ) a -= 360.0

#define  RangeSet(d, lat, lon) {\
   if( lat > d->n ) d->n = lat;\
   if( lat < d->s ) d->s = lat;\
   if( lon > d->e ) d->e = lon;\
   if( lon < d->w ) d->w = lon;\
}

void Get_Runway_Details( PGSINFO pgsi, PFGRWY prwy, PFGRWYDETAILS pd, int iVerbosity )
{
   double close_enough = SG_EPSILON * 10.0;
   double s, w, h2, h3;

   if( iVerbosity ) {
      if( prwy->rwy_no[0] == 'x' ) {
         sprtf("%s taxiway %3.6f,%3.6f, %3.2f, %5.2f\n",
            prwy->rwy_id, prwy->lat, prwy->lon, prwy->heading, prwy->length );
      } else {
         sprtf("%s # %s, %3.6f,%3.6f, %3.2f, %5.2f\n",
            prwy->rwy_id, prwy->rwy_no,
            prwy->lat, prwy->lon, prwy->heading, prwy->length );
      }
   }
   RangeSet( pd, prwy->lat, prwy->lon );

   //geo_direct_wgs_84 ( double lat1, double lon1, double az1,
   //            double s, double *lat2, double *lon2,
   //            double *az2 );
   s = prwy->length * SG_FEET_TO_METER;
   w = prwy->width * SG_FEET_TO_METER;

   h2 = 	prwy->heading + 180.0;
   NomalizeHeading( h2 );
   geo_direct_wgs_84 ( prwy->lat, prwy->lon, prwy->heading, s / 2.0,
      &pd->end1_lat, &pd->end1_lon, &pd->hdg1 );
   RangeSet( pd, pd->end1_lat, pd->end1_lon );

   geo_direct_wgs_84 ( prwy->lat, prwy->lon, h2, s / 2.0,
      &pd->end2_lat, &pd->end2_lon, &pd->hdg2 );
   RangeSet( pd, pd->end2_lat, pd->end2_lon );

   if( iVerbosity ) {
      sprtf( "Center End1 = %3.6f, %3.6f, on %3.2f, End2 = %3.6f, %3.6f, on %3.2f\n",
         pd->end1_lat, pd->end1_lon, pd->hdg1,
         pd->end2_lat, pd->end2_lon, pd->hdg2 );
   }

   // now the CORNERS of the RUNWAY
   h3 = prwy->heading + 90.0; // turn right
   NomalizeHeading(h3);       // go half width, to next corner
   geo_direct_wgs_84 ( pd->end1_lat, pd->end1_lon, h3, w / 2.0,
      &pd->cnr1_lat, &pd->cnr1_lon, &pd->hcnr1 );
   RangeSet( pd, pd->cnr1_lat, pd->cnr1_lon );

   //h3 += 90.0; // turn right
   h3 = prwy->heading + 180.0; // turn right
   NomalizeHeading(h3);       // go the full length to the other end
   geo_direct_wgs_84 ( pd->cnr1_lat, pd->cnr1_lon, h3, s,
      &pd->cnr2_lat, &pd->cnr2_lon, &pd->hcnr2 );
   RangeSet( pd, pd->cnr2_lat, pd->cnr2_lon );

   //h3 += 90.0; // turn right
   h3 = prwy->heading + 270.0; // turn right
   NomalizeHeading(h3);       // go the width to the other side
   geo_direct_wgs_84 ( pd->cnr2_lat, pd->cnr2_lon, h3, w,
      &pd->cnr3_lat, &pd->cnr3_lon, &pd->hcnr3 );
   RangeSet( pd, pd->cnr3_lat, pd->cnr3_lon );

   //h3 += 90.0; // turn right
   h3 = prwy->heading; // turn right
   NomalizeHeading(h3);       // go the length back to first end
   geo_direct_wgs_84 ( pd->cnr3_lat, pd->cnr3_lon, h3, s,
      &pd->cnr4_lat, &pd->cnr4_lon, &pd->hcnr4 );
   RangeSet( pd, pd->cnr4_lat, pd->cnr4_lon );

   // see if we arrive back at the original cnr1 ...
   //h3 += 90.0; // turn right
   h3 = prwy->heading + 90.0; // turn right
   NomalizeHeading(h3);       // go the width to the first corner
   geo_direct_wgs_84 ( pd->cnr4_lat, pd->cnr4_lon, h3, w,
      &pd->chk_lat, &pd->chk_lon, &pd->hchk );
   RangeSet( pd, pd->chk_lat, pd->chk_lon );
   // get the distance BETWEEN these two points
   geo_inverse_wgs_84( pd->cnr1_lat, pd->cnr1_lon, pd->chk_lat,
         pd->chk_lon, &pd->az1, &pd->az2, &pd->chk_dist );

   pd->diff_lat = fabs(pd->cnr1_lat - pd->chk_lat);
   pd->diff_lon = fabs(pd->cnr1_lon - pd->chk_lon);

   if( iVerbosity ) {
      sprtf( "Cnr1 %3.6f,%3.6f, 2 %3.6f,%3.6f, 3 %3.6f,%3.6f, 4 %3.6f,%3.6f\n",
         pd->cnr1_lat, pd->cnr1_lon,
         pd->cnr2_lat, pd->cnr2_lon,
         pd->cnr3_lat, pd->cnr3_lon,
         pd->cnr4_lat, pd->cnr4_lon );
   }

   if((pd->diff_lat > close_enough)||
      (pd->diff_lon > close_enough)) {
         if( iVerbosity ) {
            sprtf( "Check cnr1 %3.6f vs %3.6f (%3.6f), and %3.6f vs %3.6f (%3.6f)...\n",
               pd->cnr1_lat, pd->chk_lat,
               pd->diff_lat,
               pd->cnr1_lon, pd->chk_lon,
               pd->diff_lon );

            if( pd->chk_dist > 1.0 ) {
               sprtf( "Check distance is %0.8f m, az1 %3.2f, az2 %3.2f\n",
               pd->chk_dist, pd->az1, pd->az2 );
            } else {
               sprtf( "Check distance is %0.8f cm, az1 %3.2f, az2 %3.2f\n",
               pd->chk_dist * 100.0, pd->az1, pd->az2 );
            }
         }
   } else {
      if( iVerbosity ) {
         if( pd->chk_dist > 1.0 )
            sprtf("Close enough ;=)) %0.8f m\n", pd->chk_dist );
         else
            sprtf("Close enough ;=)) %0.8f cm\n", (pd->chk_dist * 100.0) );
      }
   }
   pd->done++;
}

#define  GET_ILATLON(a,b) Get_BMP_iLatLon( pgsi, a, b, &ilat, &ilon )

//#define  SET_ILATLON(a,b,c,d) GET_ILATLON(a,b);\
//   if( Pt_In_BMP_Boundary( pgsi, ilat, ilon )){ Add_Pt_2_BMP( pgsi, ilat, ilon, c, d ); }

void Set_Runway_Points( PGSINFO pgsi, PFGRWYDETAILS pd )
{
   int mx, my; // ASCII chars are 7 x 11
   Get_Char_Bit_Size( &mx, &my ); // 7 x 11, or whatever
   Get_BMP_iLatLon( pgsi, pd->cnr1_lat, pd->cnr1_lon, &pd->cnr1_ilat, &pd->cnr1_ilon );
   Get_BMP_iLatLon( pgsi, pd->cnr2_lat, pd->cnr2_lon, &pd->cnr2_ilat, &pd->cnr2_ilon );
   Get_BMP_iLatLon( pgsi, pd->cnr3_lat, pd->cnr3_lon, &pd->cnr3_ilat, &pd->cnr3_ilon );
   Get_BMP_iLatLon( pgsi, pd->cnr4_lat, pd->cnr4_lon, &pd->cnr4_ilat, &pd->cnr4_ilon );
   if(( pd->cnr1_ilat == pd->cnr2_ilat )&&
      ( pd->cnr2_ilat == pd->cnr3_ilat )&&
      ( pd->cnr3_ilat == pd->cnr4_ilat )&&
      ( pd->cnr1_ilon == pd->cnr2_ilon )&&
      ( pd->cnr2_ilon == pd->cnr3_ilon )&&
      ( pd->cnr3_ilon == pd->cnr4_ilon )) {
      // YEEK all as one POINT
      if( Pt_In_BMP_Boundary( pgsi, pd->cnr1_ilat, pd->cnr1_ilon ) )
         Add_Pt_2_BMP( pgsi, pd->cnr1_ilat, pd->cnr1_ilon, BMC_OLIVE, FALSE );
   } else {
      int startx, starty, endx, endy, maxy, iabs;
      BYTE b = BMC_OLIVE;
      maxy = 0;
      iabs = abs(pd->cnr1_ilat - pd->cnr2_ilat);
      if( iabs > maxy ) maxy = iabs;
      iabs = abs(pd->cnr2_ilat - pd->cnr3_ilat);
      if( iabs > maxy ) maxy = iabs;
      iabs = abs(pd->cnr3_ilat - pd->cnr4_ilat);
      if( iabs > maxy ) maxy = iabs;
      iabs = abs(pd->cnr4_ilat - pd->cnr1_ilat);
      if( iabs > maxy ) maxy = iabs;
      if( pd->prwy->type == FG_RUNWAY ) { // was strcmp(pd->prwy->rwy_no, "xxx")
         // is a RUNWAY - markings, and fill
         b = BMC_MAGENTA;
         if( maxy > (my * 2) ) { // only IF there is enough SPACE
            char * pn = pd->prwy->rwy_no;
            int len = (int)strlen(pn);
            int ilat, ilon;
            Get_BMP_iLatLon( pgsi, pd->prwy->lat, pd->prwy->lon, &ilat, &ilon );
            Add_Text_to_BMP( pgsi, ilon, ilat - (my / 2), pn, len, b );
         }
      } else {
         // taxiway ...
         b = BMC_OLIVE;
      }

      startx = pd->cnr1_ilon;
      starty = pd->cnr1_ilat;
      endx = pd->cnr2_ilon;
      endy = pd->cnr2_ilat;
      Add_Line_to_BMP( pgsi, startx, starty, endx, endy, b, FALSE);

      startx = pd->cnr2_ilon;
      starty = pd->cnr2_ilat;
      endx = pd->cnr3_ilon;
      endy = pd->cnr3_ilat;
      Add_Line_to_BMP( pgsi, startx, starty, endx, endy, b, FALSE);

      startx = pd->cnr3_ilon;
      starty = pd->cnr3_ilat;
      endx = pd->cnr4_ilon;
      endy = pd->cnr4_ilat;
      Add_Line_to_BMP( pgsi, startx, starty, endx, endy, b, FALSE);

      startx = pd->cnr4_ilon;
      starty = pd->cnr4_ilat;
      endx = pd->cnr1_ilon;
      endy = pd->cnr1_ilat;
      Add_Line_to_BMP( pgsi, startx, starty, endx, endy, b, FALSE);

   }
}

void  Adjust_Boundaries( PGSINFO pgsi, PFGRWYDETAILS pd )
{
   // Move out extra 100m to BOUNDARY
   double s = 100.0; // 100 meters
   double h, dbl, h2, lat;
   // choose lat closest equator, to get max distance
   if( pd->n < 0.0 )
      lat = pd->n;
   else
      lat = pd->s;

   if(VERB5(pgsi)) {
      sprtf( "Bounds: N %3.6f, S %3.6f, E %3.6f, W %3.6f (%d)\n",
         pd->n, pd->s, pd->e, pd->w, pd->done );
   }

   h = 270.0;
   geo_direct_wgs_84 ( lat, pd->w, h, s,
      &dbl, &pd->bw, &h2 );   // go WEST (270), for 100m, to bw
   h = 90.0;
   geo_direct_wgs_84 ( lat, pd->e, h, s,
      &dbl, &pd->be, &h2 );   // go EAST (90), for 100m, to be
   h = 0.0;
   geo_direct_wgs_84 ( pd->n, pd->w, h, s,
      &pd->bn, &dbl, &h2 );   // go NORTH (0), for 100m, to bn
   h = 180.0;
   geo_direct_wgs_84 ( pd->s, pd->e, h, s,
      &pd->bs, &dbl, &h2 );

   if(VERB5(pgsi)) {
      sprtf( "Bounds: N %3.6f, S %3.6f, E %3.6f, W %3.6f\n",
         pd->bn, pd->bs, pd->be, pd->bw );
   }
   h = 0.0;
   if( pgsi->fgdata.add_fill ) {
      int   cnta = 0;
      RECT rc;
      rc.top = rc.bottom = rc.left = rc.right = 0;
      Get_BMP_iLatLon( pgsi, pd->bn, pd->bw, (PINT)&rc.top, (PINT)&rc.left );
      Get_BMP_iLatLon( pgsi, pd->bs, pd->be, (PINT)&rc.bottom, (PINT)&rc.right );
      NormalizeRect(&rc);
      cnta = Fill_BMP_Rect( pgsi, &rc, BMC_GREEN, FALSE );
      if(VERB3(pgsi)) {
         if(cnta) {
            sprtf( "Filled rect %s ... %d points ...\n", Rect2Stg(&rc), cnta );
         } else {
            sprtf( "NO rect %s fill ...\n", Rect2Stg(&rc), cnta );
         }
      }
   }
}

// add FG airport, runways, and taxiways DETAIL
// ============================================
void Work_With_List( PGSINFO pgsi )
{
   PLE phapts = &pgsi->fgdata.apts;
   PLE phrwys = &pgsi->fgdata.rwys;
   PLE pna, pnr;
   int   cnta, cntr;
   int   ilat, ilon;
   PFGRWYDETAILS pd = &rwyd;

   ListCount2(phapts,&cnta);
   ListCount2(phrwys,&cntr);
   if(VERB3(pgsi)) {
      if( bAdd_All_Taxi )
         sprtf( "Found %d airports, with %d runways/taxiways in lists ...\n", cnta, cntr );
      else
         sprtf( "Found %d airports, with %d runways in lists ...\n", cnta, cntr );
   }
   Traverse_List( phapts, pna )
   {
      PFGAPT papt = (PFGAPT)pna;
      if(VERB5(pgsi)) {
         sprtf( "\n%s %3.6f,%3.6f,%3.1f %s\n",
            papt->apt_id,
            papt->lat,
            papt->lon,
            papt->elev,
            papt->apt_name );
      }
      pd->done = 0;
      pd->n = -91.0;
      pd->s = 91.0;
      pd->e = -181.0;
      pd->w = 181.0;
      RangeSet( pd, papt->lat, papt->lon );
      pd->papt = papt;  // pass on the AIRPORT being done
      Get_BMP_iLatLon( pgsi, papt->lat, papt->lon, &ilat, &ilon );
      Add_Pt_2_BMP( pgsi, ilat, ilon, BMC_FUCHIA, TRUE );
      if( pgsi->fgdata.add_id ) {
         Add_Text_to_BMP( pgsi, ilon, ilat, papt->apt_id,
            (int)strlen(papt->apt_id), BMC_FUCHIA );

      }
      if( pgsi->fgdata.add_name ) {
         Add_Text_to_BMP( pgsi, ilon, ilat - 11, papt->apt_name,
            (int)strlen(papt->apt_name), BMC_FUCHIA );
      }

      // do only RUNWAYS first
      Traverse_List( phrwys, pnr )
      {
         PFGRWY prwy = (PFGRWY)pnr;
         if( strcmp(papt->apt_id, prwy->rwy_id) == 0 ) {
            if( prwy->type == FG_RUNWAY ) {
               pd->prwy = prwy;  // and the RUNWAY/TAXIWAY being DONE
               Get_Runway_Details( pgsi, prwy, pd, iVerbal );
               Set_Runway_Points( pgsi, pd );   // add POINTS to BMP
            }
         }
      }

      // then do TAXIWAYS
      Traverse_List( phrwys, pnr )
      {
         PFGRWY prwy = (PFGRWY)pnr;
         if( strcmp(papt->apt_id, prwy->rwy_id) == 0 ) {
            if( prwy->type != FG_RUNWAY ) { // was strcmp(prwy->rwy_no,"xxx")
               pd->prwy = prwy;  // and the RUNWAY/TAXIWAY being DONE
               Get_Runway_Details( pgsi, prwy, pd, iVerbal );
               if( pgsi->fgdata.add_all ) // if add ALL
                  Set_Runway_Points( pgsi, pd );   // add POINTS to BMP
            }
         }
      }

      // really need to move BOUNDARIES OUT a little, say 100m!!!
      // ============================================================
      Adjust_Boundaries( pgsi, pd );   // adjust, and maybe FILL RECT
      // ============================================================
   }

}

#endif // #ifndef  NO_ADD_FG_DATA

// eof - apt_dat.cxx

